/*
  Autheur:      Fun met Electronica
  Link:         https://training.funmetelectronica.nl/docs/arduino-basis/lessen/les-7-tonekeyboard/
  Beschrijving: In deze sketch gaan we de arduino ombouwen tot een keyboard.
                We beginnen met een keyboard met 2 toetsen (knoppen).
*/

/*
  Hier worden de noten met bijbehorende frequentie beschreven.
  Kijk maar eens in het tabblad pitches.h,
  op elke regel is het laatste getal de frequentie van de toon.
 */
#include "pitches.h"

const int knop1 = 2;        // knop 1 is aangesloten op pin 2
const int knop2 = 3;        // knop 2 is aangesloten op pin 3

const int speaker = 8;      // de buzzer of speaker is aangesloten op pin 8
const int toon1 = NOTE_C4;  // de toon die hoort bij de noot
const int toon2 = NOTE_D4;  // de toon die hoort bij de noot

int toestandknop1 = 0;      // de waarde van knop 1
int toestandknop2 = 0;      // de waarde van knop 2

/*
  Het programmablok void setup wordt eenmaal beschreven
*/
void setup() {
  pinMode(knop1, INPUT);      // knop1 is een input
  pinMode(knop2, INPUT);      // knop2 is een input
  pinMode (speaker, OUTPUT);  // speaker is een output
}

/*
  Het programmablok void loop herhaalt zich keer op keer
*/
void loop() {
  toestandknop1 = digitalRead(knop1); // lees toestand knop1
  toestandknop2 = digitalRead(knop2); // lees toestand knop1

  if (toestandknop1 == HIGH) {
    tone(speaker, toon1);             // toon 1 klinkt bij knop1
  } else if (toestandknop2 == HIGH) {
    tone(speaker, toon2);             // toon 2 klinkt bij knop2
  } else {
    noTone(speaker);                  // geen toon zonder knop ingedrukt
  }
}

/*
  Opdracht 1:
  Maak een derde knop erbij met een nieuwe toon.

  Opdracht 2:
  In plaats van knoppen gebruik een LDR.
*/
